package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamArrangementSubAddBo;
import com.zhongzheng.modules.exam.bo.ExamArrangementSubQueryBo;
import com.zhongzheng.modules.exam.bo.ExamArrangementSubEditBo;
import com.zhongzheng.modules.exam.domain.ExamArrangementSub;
import com.zhongzheng.modules.exam.mapper.ExamArrangementSubMapper;
import com.zhongzheng.modules.exam.vo.ExamArrangementSubVo;
import com.zhongzheng.modules.exam.service.IExamArrangementSubService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author change
 * @date 2021-06-08
 */
@Service
public class ExamArrangementSubServiceImpl extends ServiceImpl<ExamArrangementSubMapper, ExamArrangementSub> implements IExamArrangementSubService {

    @Override
    public ExamArrangementSubVo queryById(Long examId){
        ExamArrangementSub db = this.baseMapper.selectById(examId);
        return BeanUtil.toBean(db, ExamArrangementSubVo.class);
    }

    @Override
    public List<ExamArrangementSubVo> queryList(ExamArrangementSubQueryBo bo) {
        LambdaQueryWrapper<ExamArrangementSub> lqw = Wrappers.lambdaQuery();
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamArrangementSubVo> entity2Vo(Collection<ExamArrangementSub> collection) {
        List<ExamArrangementSubVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamArrangementSubVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamArrangementSub> page = (Page<ExamArrangementSub>)collection;
            Page<ExamArrangementSubVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamArrangementSubAddBo bo) {
        ExamArrangementSub add = BeanUtil.toBean(bo, ExamArrangementSub.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamArrangementSubEditBo bo) {
        ExamArrangementSub update = BeanUtil.toBean(bo, ExamArrangementSub.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamArrangementSub entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
